# throttle average i/o rate

#	$Header: /cvsroot/subterfugue/subterfugue/tricks/ThrottleIOTrick.py,v 1.2 2000/02/26 05:29:14 mkc Exp $

from Trick import Trick

import sys
import time

class ThrottleIO(Trick):
    def usage(self):
        return """
        Delays read and write calls so that the average I/O rate (via these
        calls) is limited.  The 'bps' parameter is required and is the I/O
        limit, in bytes per second.
"""
    
    def __init__(self, options):
        if options.has_key('bps'):
            self.bps = options['bps']
        else:
            sys.exit("error: %s: option required\nusage:%s"
                     % (self.__class__.__name__, self.usage()))

    def callbefore(self, pid, call, args):
        assert call == 'read' or call == 'write'
        time.sleep(float(args[2]) / self.bps)
        
    def callmask(self):
        return { 'read' : 1, 'write' : 1 }
